#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: pgsql.tcl,v 1.1 2000/12/01 10:59:33 artur Exp $
#
# Information:
# pgsql<--> Xotcl interface (proxy)

Class PgSql -superclass Sqlinterface -parameter {
    user
    password
    hostname
    {interface postgresql}
}
PgSql set interface postgresql
# Instanz Variablen
# sqlhandle - Handle fr 
PgSql instproc init args {
    #package require Pgtcl
    next
}
PgSql instproc getconnectargs {} {
    global env
    [self] instvar dbank
    foreach arg [pg_conndefaults] {
	if {[lindex $arg 0]=="password"} {
	    lappend connlist [list [lindex $arg 0] password [lindex $arg 4]]
	} else {
	    lappend connlist [list [lindex $arg 0] text [lindex $arg 4]]
	    if {[lindex $arg 0]=="dbname"} {
		set dbank [lindex $arg 4]
	    }
	}
    }
    return $connlist
}

PgSql instproc connect par_list {
    [self] instvar sqlhandle connected dbank user password hostname
    set conninfo {}
    foreach par [keylkeys par_list] {
	if {[keylget par_list $par]!=""} {
	    if {$par=="interface"} {
		continue
	    }
	    if {$par=="dbname"} {
		set dbank [keylget par_list dbname]
	    }
	    [self]  instvar $par
	    set $par [keylget par_list $par]
	    lappend conninfo "$par='[keylget par_list $par]'"
	}
    }
    #puts "PGSQL $conninfo"
    if {[catch {set sqlhandle [pg_connect -conninfo $conninfo]} err]!=0} {
	global errorInfo
	puts "$err $errorInfo"
	return 1
    }
    set connected 1
}

PgSql instproc disconnect {} {
    [self] instvar sqlhandle connected
    if {$connected} {
	pg_disconnect $sqlhandle
    }
    set connected 0
}
PgSql instproc getdblist {} {
    error "postgresql interface don't support this funktionality. You must know names of your databases"
}
PgSql instproc setdb dbname {
    error "postgresql interface don't support this funktionality. You must know names of your databases"
}
PgSql instproc query sqlstatment {
    [self] instvar sqlhandle error_msg
    set qhandle [pg_exec $sqlhandle $sqlstatment]
    set name [Object autoname mySqlQuerry]
    #puts "Querry Status [pg_result $qhandle -status]"
    if {[pg_result $qhandle -status]=="PGRES_FATAL_ERROR"} {
	set error_msg [pg_result $qhandle -error]
	catch {
	    error "Postgres SQL Error" $error_msg
	}
	pg_result $qhandle -clear
	return {}
    }
    PSqlQuerry [self]::$name -qhandle $qhandle
    return [self]::$name
}
# Sendet eine SQL Anweisung an Server (keine SELECT)
PgSql instproc execute sqlstatement {
    [self] instvar sqlhandle error_msg
    set qhandle [pg_exec $sqlhandle $sqlstatement]
    if {[pg_result $qhandle -status]=="PGRES_FATAL_ERROR"} {
	set error_msg [pg_result $qhandle -error]
	catch {
	    error "Postgres SQL Error" $error_msg
	}
	pg_result $qhandle -clear
	return {}
    }
    pg_result $qhandle -clear
    return 0
}
Class PSqlQuerry -parameter {
    {qhandle}
    {tindex 0}
    {numTuples}
}
PSqlQuerry instproc init {args} {
    next
    [self] instvar numTuples qhandle
    set numTuples [pg_result $qhandle -numTuples]
}
PSqlQuerry instproc fetch {} {
    [self] instvar qhandle tindex numTuples
    if {$tindex<$numTuples} {
	set result [pg_result $qhandle -getTuple $tindex]
	incr tindex
    } else {
	set result {}
    }
    #puts "fetch $tindex $result"
    return $result
}
PSqlQuerry instproc getinsertid {} {
    [self] instvar qhandle
    return [pg_result $qhandle -oid]
}
PSqlQuerry instproc rows {} {
    [self] instvar numTuples
    return $numTuples
}
PSqlQuerry instproc seek {point} {
    [self] instvar tindex
    set tindex $point
}
PSqlQuerry instproc destroy {} {
    [self] instvar qhandle 
    pg_result $qhandle -clear
    next
}
