#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: sql.tcl,v 1.14 2000/12/01 10:49:33 artur Exp $
#
# Information:
# Modul (benutzt von Schema Editor und Form Server)
# Diese Datei beinhaltet die Abstrakte XOTcl Klasse
# Sqlinterface

Class Sqlinterface -parameter {dbank {connected 0}}
Sqlinterface abstract instproc getconnectargs {}
Sqlinterface abstract instproc connect par_list
Sqlinterface abstract instproc getdblist {}
Sqlinterface abstract instproc setdb dbname
Sqlinterface abstract instproc disconnect {}
Sqlinterface instproc destroy {} {
    # Vielleicht bracht das Klassenkind noch die Verbindung
    #next
    # Next verursacht ein Fehler +++ ::Cant find self
    [self] instvar connected
    if {$connected} {
	[self] disconnect
    }
    next
}
Sqlinterface instproc escape string {
    regsub -all {\\} $string {\\\\} string
    regsub -all \" $string {\"} string
    regsub -all \' $string {\'} string
    return $string
}
# Sqlinterface instproc connectfilter args {
#puts filtered
#     set needconnect {
# 	getdblist
# 	setdb
#     }
#     if {[lsearch $needconnect [[self] info calledproc]]!=-1} {
# 	[self] instvar connected
# 	if {$connected==0} { error {mysql not connected}}
#     }
#     [self] next
# }
#Sqlinterface filter connectfilter

# braucht geladenes Array lan fr internationalle untersttzung und
# widgetlib.tcl und dialog.tcl
# hat ein dialog fr sql Verbindung zu Kreiren und ein SqlInterface
# Object zurckzugeben oder nicht wenn milungen
Object ConnectCreator
ConnectCreator proc getconnect {name {cpar {}} {withSchemaExt 0}} {
    global lan dbinterfaces
    #puts "cpar $cpar"
    set cpark [keylkeys cpar]
    #  Finde alle DB Interfaces
    set interfaces {}
    foreach iface $dbinterfaces {
	lappend interfaces [lindex $iface 0]
	keylset if_classes [lindex $iface 0] [lindex $iface 2]
    }
    if {$interfaces==""} {
	bgerror {No DB Interfaces fond. Please adapt the Init.tcl file}
    }
    # berschreibe wenn interface bereits bestimmt
    if {[lcontain $cpark interface]} {
	set interfaces [keylget cpar interface]
    }
    # Benutzer soll interface bestimmen
    if {[llength $interfaces]>1} {
	set interfacelist {{type OComboBox} {name interface}}
	keylset interfacelist label $lan(connect.interfacelist)
	keylset interfacelist valuelist $interfaces
	#puts $interfacelist
	WidgetFactory make_inputs_keylist [self]::inputframe [list $interfacelist]
	ODialog interfacedialog -title $lan(connect.chooseinterface) \
	    -message $lan(connect.chooseinterface)\
	    -inputframe [self]::inputframe -type okcancel
	if {[interfacedialog execute]=="cancel"} { return {}}
	set value [[self]::inputframe get_values]
	set interface [keylget value interface]
	interfacedialog destroy
	[self]::inputframe destroy
    } else {
	set interface $interfaces
    }
    [self] loadondemand $interface $withSchemaExt
    # Interface Objekt bilden
    set iclass [keylget if_classes $interface]
    if {$withSchemaExt} {
	# Hier wird vorausgesetzt das die Kindklasse die 
	# Schema-Auslese Operationen beinhaltet
	set iclass [$iclass info subclass]
    }
    $iclass $name
    # Dialog fr Attributte des Verbindung zu konkreten DB bilden
    set par [$name getconnectargs]
    foreach arg $par {
	set tpar {}
	# setzt die Reiehnfolge typ name label default
	lappend tpar [lindex $arg 1]
	lappend tpar [lindex $arg 0]
	lappend tpar $lan(connect.[lindex $arg 0])
	# Wenn argument in par schon vorgegeban dann setzte auf default
	if {[lsearch $cpar [lindex $arg 0]*]!=-1} {
	    lappend tpar [keylget cpar [lindex $arg 0]]
	    #puts "inherit [lindex $arg 0] [keylget cpar [lindex $arg 0]]"
	} else {
	    lappend tpar [lindex $arg 2]
	}
	lappend inputs $tpar
    }
    WidgetFactory make_simply_inputs cinput $inputs
    ODialog connectdialog -title $lan(connect.mysql) \
	-message $lan(connect.mysql)\
	-inputframe cinput -type okcancel
    if {[connectdialog execute]=="cancel"} { 
	$name destroy
	connectdialog destroy
	cinput destroy
	return {}
    }
    set par [cinput get_changes]
    # Varibale par beinhaltet nur dir Vernderungen
    # alle vorgaben dazugeben (Variable cpar)
    # Welche Werte m
    foreach inhkey $cpark {
	if {![lcontain [keylkeys par] $inhkey]} {
	    keylset par $inhkey [keylget cpar $inhkey]
	}
    }
    $name connect $par
    connectdialog destroy
    cinput destroy
    if {[$name set connected]==0} {
	$name destroy
	return {}
    }
    # Wurde die Datenbank Ausgewlt?
    if {![info exist ${name}::dbank] || [set ${name}::dbank]==""} {
	set interfacelist {{type OComboBox} {name interface}}
	keylset interfacelist label $lan(connect.dbanklist)
	keylset interfacelist valuelist [$name getdblist]
	#puts $interfacelist
	WidgetFactory make_inputs_keylist [self]::inputframe [list $interfacelist]
	ODialog interfacedialog \
	    -message $lan(connect.choosedbank)\
	    -inputframe [self]::inputframe -type okcancel
	if {[interfacedialog execute]=="cancel"} { return {}}
	set value [[self]::inputframe get_values]
	$name setdb [keylget value interface]
	if {[$name set dbank]==""} {
	    $name disconnect
	    $name destroy
	    return {}
	}
	interfacedialog destroy
	[self]::inputframe destroy
    }
    return $name
}

ConnectCreator proc loadondemand {name {withext 0}} {
    global dbinterfaces progdir
    set finterface {}
    foreach interface $dbinterfaces {
	if {$name==[lindex $interface 0]} {
	    set finterface $interface
	    break
	}	
    }
    if {$finterface==""} {
	bgerror "interface not found"
    }
    # bereits geladen?
    if {[Object isobject [lindex $finterface 2]]} return
    source [file join $progdir [lindex $finterface 3]]
    # load library
    load [lindex $finterface 1]
    # load module for schema extraction
    if {$withext} {
	source [file join $progdir [lindex $finterface 4]]
    }
}
